<?php
namespace zacksleo\yii\plugin\models;

/**
 * This is the model class for table "{{plugins}}".
 *
 * The followings are the available columns in table '{{plugins}}':
 * @property integer $plugin_id
 * @property string $identify
 * @property string $path
 * @property string $hooks
 * @property integer $enable
 */
class Plugins extends \CActiveRecord
{
    /**
     * @return string the associated database table name
     */
    public function tableName()
    {
        return '{{plugins}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules()
    {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('identify, path, hooks', 'required'),
            array('enable', 'numerical', 'integerOnly' => true),
            array('identify', 'length', 'max' => 45),
            array('path', 'length', 'max' => 255),
            array('identify', 'unique'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('plugin_id, identify, path, hooks, enable', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations()
    {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array();
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels()
    {
        return array(
            'plugin_id' => 'Plugin',
            'identify' => 'Identify',
            'path' => 'Path',
            'hooks' => 'Hooks',
            'enable' => 'Enable',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search()
    {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('plugin_id', $this->plugin_id);
        $criteria->compare('identify', $this->identify, true);
        $criteria->compare('path', $this->path, true);
        $criteria->compare('hooks', $this->hooks, true);
        $criteria->compare('enable', $this->enable);

        return new \CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Plugins the static model class
     */
    public static function model($className = __class__)
    {
        return parent::model($className);
    }
}
